Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 644)
@@ -2072,234 +2388,9 @@
       enddo
 
+c
 cIM calcul nuages par le simulateur ISCCP
+c
       IF (ok_isccp) THEN
-cIM calcul tau. emi nuages convectifs
-      convfra(:,:)=rnebcon(:,:)
-      convliq(:,:)=rnebcon(:,:)*clwcon(:,:)
-      CALL newmicro (paprs, pplay,ok_newmicro,
-     .            t_seri, convliq, convfra, dtau_c, dem_c,
-     .            cldh_c, cldl_c, cldm_c, cldt_c, cldq_c,
-     .            flwp_c, fiwp_c, flwc_c, fiwc_c,
-     e            ok_aie,
-     e            sulfate, sulfate_pi,
-     e            bl95_b0, bl95_b1,
-     s            cldtaupi, re, fl)
-c
-cIM calcul tau. emi nuages startiformes
-      CALL newmicro (paprs, pplay,ok_newmicro,
-     .            t_seri, cldliq, cldfra, dtau_s, dem_s,
-     .            cldh_s, cldl_s, cldm_s, cldt_s, cldq_s,
-     .            flwp_s, fiwp_s, flwc_s, fiwc_s,
-     e            ok_aie,
-     e            sulfate, sulfate_pi,
-     e            bl95_b0, bl95_b1,
-     s            cldtaupi, re, fl)
-c
-      cldtot(:,:)=min(max(cldfra(:,:),rnebcon(:,:)),1.)
-
-cIM inversion des niveaux de pression ==> de haut en bas
-      CALL haut2bas(klon, klev, pplay, pfull)
-      CALL haut2bas(klon, klev, q_seri, qv)
-      CALL haut2bas(klon, klev, cldtot, cc)
-      CALL haut2bas(klon, klev, rnebcon, conv)
-      CALL haut2bas(klon, klev, dtau_s, dtau_sH2B)
-      CALL haut2bas(klon, klev, dtau_c, dtau_cH2B)
-      CALL haut2bas(klon, klev, t_seri, at)
-      CALL haut2bas(klon, klev, dem_s, dem_sH2B)
-      CALL haut2bas(klon, klev, dem_c, dem_cH2B)
-      CALL haut2bas(klon, klevp1, paprs, phalf)
-
-c     open(99,file='tautab.bin',access='sequential',
-c    $     form='unformatted',status='old')
-c     read(99) tautab
-
-cIM210503
-      IF (debut) THEN
-      open(99,file='tautab.formatted', FORM='FORMATTED')
-      read(99,'(f30.20)') tautab
-      close(99)
-c
-      open(99,file='invtau.formatted',form='FORMATTED')
-      read(99,'(i10)') invtau
-      close(99)
-c
-cIM: calcul coordonnees regions pour statistiques distribution 
-cIM: nuages en ftion du regime dynamique pour regions oceaniques
-       IF (ok_regdyn) THEN !histREGDYN
-       nsrf=3
-       DO nreg=1, nbregdyn
-       DO i=1, klon
-
-c       IF (debut) THEN
-         IF(rlon(i).LT.0.) THEN
-           rlonPOS(i)=rlon(i)+360.
-         ELSE
-           rlonPOS(i)=rlon(i)  
-         ENDIF
-c       ENDIF
-
-        pct_ocean(i,nreg)=0
-
-c test si c'est 1 point d'ocean
-        IF(pctsrf(i,nsrf).EQ.1.) THEN
-
-         IF(nreg.EQ.1) THEN
-
-c TROP
-          IF(rlat(i).GE.-30.AND.rlat(i).LE.30.) THEN
-           pct_ocean(i,nreg)=1
-          ENDIF
-
-c PACIFIQUE NORD
-          ELSEIF(nreg.EQ.2) THEN
-           IF(rlat(i).GE.40.AND.rlat(i).LE.60.) THEN
-            IF(rlonPOS(i).GE.160..AND.rlonPOS(i).LE.235.) THEN 
-             pct_ocean(i,nreg)=1
-            ENDIF
-           ENDIF
-c CALIFORNIE ST-CU
-         ELSEIF(nreg.EQ.3) THEN
-          IF(rlonPOS(i).GE.220..AND.rlonPOS(i).LE.250.) THEN
-           IF(rlat(i).GE.15.AND.rlat(i).LE.35.) THEN
-            pct_ocean(i,nreg)=1
-           ENDIF
-          ENDIF
-c HAWAI
-        ELSEIF(nreg.EQ.4) THEN 
-         IF(rlonPOS(i).GE.180..AND.rlonPOS(i).LE.220.) THEN
-          IF(rlat(i).GE.15.AND.rlat(i).LE.35.) THEN
-           pct_ocean(i,nreg)=1
-          ENDIF
-         ENDIF
-c WARM POOL
-        ELSEIF(nreg.EQ.5) THEN 
-         IF(rlonPOS(i).GE.70..AND.rlonPOS(i).LE.150.) THEN
-          IF(rlat(i).GE.-5.AND.rlat(i).LE.20.) THEN
-           pct_ocean(i,nreg)=1
-          ENDIF
-         ENDIF
-        ENDIF !nbregdyn
-c TROP
-c        IF(rlat(i).GE.-30.AND.rlat(i).LE.30.) THEN
-c         pct_ocean(i)=.TRUE.
-c         WRITE(*,*) 'pct_ocean =',i, rlon(i), rlat(i)
-c          ENDIF !lon
-c         ENDIF !lat
-
-        ENDIF !pctsrf
-       ENDDO !klon
-       ENDDO !nbregdyn
-       ENDIF !ok_regdyn
- 
-cIM somme de toutes les nhistoW BEG
-      DO nreg = 1, nbregdyn
-       DO k = 1, kmaxm1
-        DO l = 1, lmaxm1
-         DO iw = 1, iwmax
-          nhistoWt(k,l,iw,nreg)=0.
-         ENDDO !iw
-        ENDDO !l
-       ENDDO !k
-      ENDDO !nreg
-cIM somme de toutes les nhistoW END
-      ENDIF
-cIM: initialisation de seed
-        DO i=1, klon
-          seed(i)=i+100
-        ENDDO
-     
-cIM: pas de debug, debugcol
-      debug=0
-      debugcol=0
-cIM260503
-c o500 ==> distribution nuage ftion du regime dynamique a 500 hPa
-        DO k=1, klevm1
-        kp1=k+1
-c       PRINT*,'k, presnivs',k,presnivs(k), presnivs(kp1)
-        if(presnivs(k).GT.50000.AND.presnivs(kp1).LT.50000.) THEN
-         DO i=1, klon
-          o500(i)=omega(i,k)*RDAY/100.
-c         if(i.EQ.1) print*,' 500hPa lev',k,presnivs(k),presnivs(kp1)
-         ENDDO
-         GOTO 1000
-        endif 
-1000  continue
-      ENDDO
-
-      CALL ISCCP_CLOUD_TYPES(
-     &     debug,
-     &     debugcol,
-     &     klon,
-     &     sunlit,
-     &     klev,
-     &     ncol,
-     &     seed,
-     &     pfull,
-     &     phalf,
-     &     qv, cc, conv, dtau_sH2B, dtau_cH2B,
-     &     top_height,
-     &     overlap,
-     &     tautab,
-     &     invtau,
-     &     ztsol,
-     &     emsfc_lw,
-     &     at, dem_sH2B, dem_cH2B,
-     &     fq_isccp,
-     &     totalcldarea,
-     &     meanptop,
-     &     meantaucld,
-     &     boxtau,
-     &     boxptop)
-
-
-c passage de la grille (klon,7,7) a (iim,jjmp1,7,7)
-      DO l=1, lmaxm1
-       DO k=1, kmaxm1
-        DO i=1, iim
-         fq4d(i,1,k,l)=fq_isccp(1,k,l) 
-        ENDDO
-        DO j=2, jjm
-         DO i=1, iim
-          ig=i+1+(j-2)*iim
-          fq4d(i,j,k,l)=fq_isccp(ig,k,l)              
-         ENDDO
-        ENDDO
-        DO i=1, iim
-         fq4d(i,jjmp1,k,l)=fq_isccp(klon,k,l) 
-        ENDDO
-       ENDDO 
-      ENDDO 
-c
-      DO l=1, lmaxm1
-       DO k=1, kmaxm1  
-        DO j=1, jjmp1
-         DO i=1, iim
-           ni=(i-1)*lmaxm1+l
-           nj=(j-1)*kmaxm1+k
-           fq3d(ni,nj)=fq4d(i,j,k,l)
-         ENDDO
-        ENDDO
-       ENDDO
-      ENDDO
-
-c
-c calculs statistiques distribution nuage ftion du regime dynamique 
-c
-c Ce calcul doit etre fait a partir de valeurs mensuelles ??
-      CALL histo_o500_pctau(nbregdyn,pct_ocean,o500,fq_isccp,
-     &histoW,nhistoW)
-c
-c nhistoWt = somme de toutes les nhistoW
-      DO nreg=1, nbregdyn
-       DO k = 1, kmaxm1
-        DO l = 1, lmaxm1
-         DO iw = 1, iwmax
-          nhistoWt(k,l,iw,nreg)=nhistoWt(k,l,iw,nreg)+
-     &    nhistoW(k,l,iw,nreg)
-         ENDDO
-        ENDDO
-       ENDDO
-      ENDDO
-c
+#include "calcul_simulISCCP.h"
       ENDIF !ok_isccp
 
@@ -2571,5 +2662,6 @@
      e                   igwd,idx,itest,
      e                   t_seri, u_seri, v_seri,
-     s                   zulow, zvlow, zustr, zvstr,
+cIM 141004    s                   zulow, zvlow, zustr, zvstr,
+     s                   zulow, zvlow, zustrdr, zvstrdr,
      s                   d_t_oro, d_u_oro, d_v_oro)
 c
@@ -2603,5 +2695,5 @@
      e                   itest,
      e                   t_seri, u_seri, v_seri,
-     s                   zulow, zvlow, zustr, zvstr,
+     s                   zulow, zvlow, zustrli, zvstrli,
      s                   d_t_lif, d_u_lif, d_v_lif)
 c
@@ -2616,4 +2708,31 @@
 c
       ENDIF ! fin de test sur ok_orolf
+c
+cIM cf. FLott BEG
+C STRESS NECESSAIRES: TOUTE LA PHYSIQUE
+
+      DO i = 1, klon
+        zustrph(i)=0.
+        zvstrph(i)=0.
+      ENDDO
+      DO k = 1, klev
+      DO i = 1, klon
+       zustrph(i)=zustrph(i)+(u_seri(i,k)-u(i,k))/dtime*
+     c            (paprs(i,k)-paprs(i,k+1))/rg
+       zvstrph(i)=zvstrph(i)+(v_seri(i,k)-v(i,k))/dtime*
+     c            (paprs(i,k)-paprs(i,k+1))/rg
+      ENDDO
+      ENDDO
+c
+cIM calcul composantes axiales du moment angulaire et couple des montagnes
+c
+      CALL aaam_bud (27,klon,klev,rjourvrai,gmtime,
+     C               ra,rg,romega,
+     C               rlat,rlon,pphis,
+     C               zustrdr,zustrli,zustrph,
+     C               zvstrdr,zvstrli,zvstrph,
+     C               paprs,u,v,
+     C               aam, torsfc)
+cIM cf. FLott END
 c
       IF (if_ebil.ge.2) THEN 
@@ -2712,7 +2831,11 @@
      s                   ve, vq, ue, uq)
 c
+cIM diag. bilKP
+c
+      CALL transp_lay (paprs,zxtsol,
+     e                   t_seri, q_seri, u_seri, v_seri, zphi,
+     s                   ve_lay, vq_lay, ue_lay, uq_lay)
+c
 c Accumuler les variables a stocker dans les fichiers histoire:
-c
-c
 c
 c+jld ec_conser
@@ -2750,62 +2873,8 @@
 c=======================================================================
 
-c   Interpollation sur quelques niveaux de pression
-c   -----------------------------------------------
-c
-c on moyenne mensuellement les champs 3D et on les interpole sur les niveaux STD
-c     if(itap.EQ.1.OR.itap.EQ.13.OR.itap.EQ.25.OR.itap.EQ.37) THEN
-c     if(MOD(itap,12).EQ.1) THEN
-cIM 120304 END
-      DO k=1, nlevSTD
-       call plevel(klon,klev,.true.,pplay,rlevSTD(k),
-     .             t_seri,tlevSTD(:,k))
-       call plevel(klon,klev,.false.,pplay,rlevSTD(k),
-     .             u_seri,ulevSTD(:,k))
-       call plevel(klon,klev,.false.,pplay,rlevSTD(k),
-     .             v_seri,vlevSTD(:,k))
-       call plevel(klon,klev,.false.,pplay,rlevSTD(k),
-     .             zphi,philevSTD(:,k))
-       call plevel(klon,klev,.false.,pplay,rlevSTD(k),
-     .             qx(:,:,ivap),qlevSTD(:,k))
-       call plevel(klon,klev,.false.,pplay,rlevSTD(k),
-     .             zx_rh,rhlevSTD(:,k))
-      ENDDO !nlevSTD
-c ENSEMBLES BEG
-      DO k=1, nlevENS
-cIM 170304
-       tlev(:,k)=tlevSTD(:,indENS(k))
-       ulev(:,k)=ulevSTD(:,indENS(k))
-       vlev(:,k)=vlevSTD(:,indENS(k))
-       philev(:,k)=philevSTD(:,indENS(k))
-       qlev(:,k)=qlevSTD(:,indENS(k))
-       rhlev(:,k)=rhlevSTD(:,indENS(k))
-c
-       call plevel(klon,klevp1,.true.,paprs,rlevENS(k),
-     .             omega,wlev(:,k))
-c
-       ENDDO !k=1, nlevENS 
-cIM 100304 BEG
-cIM interpolation a chaque pas de temps du SWup(clr) et SWdn(clr) a 200 hPa
-      call plevel(klon,klevp1,.true.,paprs,20000.,
-     $     swdn0,SWdn200clr)
-      call plevel(klon,klevp1,.false.,paprs,20000.,
-     $     swdn,SWdn200)
-      call plevel(klon,klevp1,.false.,paprs,20000.,
-     $     swup0,SWup200clr)
-      call plevel(klon,klevp1,.false.,paprs,20000.,
-     $     swup,SWup200)
-c
-      call plevel(klon,klevp1,.false.,paprs,20000.,
-     $     lwdn0,LWdn200clr)
-      call plevel(klon,klevp1,.false.,paprs,20000.,
-     $     lwdn,LWdn200)
-      call plevel(klon,klevp1,.false.,paprs,20000.,
-     $     lwup0,LWup200clr)
-      call plevel(klon,klevp1,.false.,paprs,20000.,
-     $     lwup,LWup200)
-c
-cIM 100304 END
-c     
-c ENSEMBLES END
+cIM Interpolation sur les niveaux de pression du NMC
+c   -------------------------------------------------
+c
+#include "calcul_STDlev.h"
 c
 c slp sea level pressure
@@ -2821,31 +2890,8 @@
       ENDDO
 c
-cIM sorties bilans energie cinetique et potentielle MJO
-      DO k = 1, klev
-      DO i = 1, klon
-        d_u_oli(i,k) = d_u_oro(i,k) + d_u_lif(i,k)
-        d_v_oli(i,k) = d_v_oro(i,k) + d_v_lif(i,k)
-      ENDDO
-      ENDDO
-c
-      IF (MOD(itap-1,lmt_pas) .EQ. 0) THEN
-cIM      PRINT *,' PHYS cond  julien ',julien
-c        CALL ozonecm( FLOAT(julien), rlat, paprs, wo)
-        DO i = 1, klon
-         total_rain(i)=rain_fall(i)+snow_fall(i)  
-         IF(total_rain(i).GT.0.) nday_rain(i)=nday_rain(i)+1.
-        ENDDO
-c 
-      ENDIF
-c surface terre
-      IF (debut) THEN
-       DO i=1, klon
-         IF(pctsrf_new(i,is_ter).GT.0.) THEN
-            paire_ter(i)=airephy(i)*pctsrf_new(i,is_ter)
-         ENDIF 
-       ENDDO
-      ENDIF
-cIM 050204 END
-
+cIM initialisation + calculs divers diag AMIP2
+c
+#include "calcul_divers.h"
+c
 c=============================================================
 c
@@ -2872,4 +2918,8 @@
       ENDIF
 c
+cIM rajout diagnostiques bilan KP pour analyse MJO par Jun-Ichi Yano
+c#include "write_bilKP_ins.h"
+c#include "write_bilKP_ave.h"
+c
 c Sauvegarder les valeurs de t et q a la fin de la physique:
 c
@@ -2893,4 +2943,5 @@
 #ifdef histday
 #include "write_histday.h"
+#include "write_histday_seri.h"
 #endif
 
@@ -2910,4 +2961,5 @@
 #include "write_histISCCP.h"
 #endif
+
 
 #ifdef histmthNMC
@@ -2957,5 +3009,8 @@
 ccc         IF (ok_oasis) CALL quitcpl
          CALL phyredem ("restartphy.nc",dtime,radpas,
-     .      rlat, rlon, pctsrf, ftsol, ftsoil, deltat, fqsurf, qsol,
+     .      rlat, rlon, pctsrf, ftsol, ftsoil,
+cIM "slab" ocean
+     .      tslab, seaice, 
+     .      fqsurf, qsol,
      .      fsnow, falbe,falblw, fevap, rain_fall, snow_fall,
      .      solsw, sollwdown,dlw,
Index: /LMDZ4/trunk/libf/phylmd/phytrac.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phytrac.F	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/phytrac.F	(revision 644)
@@ -628,5 +628,5 @@
 
       if (thermiques) then
-        print*,'calcul de leffet des thermiques'
+c        print*,'calcul de leffet des thermiques'
         nsplit=10
         DO it=1, nqmax
@@ -652,5 +652,5 @@
             enddo
           enddo ! nsplit
-          print*,'apres thermiques'
+c          print*,'apres thermiques'
 c             call dump2d(iim,jjm-1,d_tr_th(1,1,1),'d_tr_th      ')
 c            do k=1,klev
@@ -868,5 +868,5 @@
          close(99)
       else
-         print*, 'physique pas fini'
+c         print*, 'physique pas fini'
       endif
 
Index: /LMDZ4/trunk/libf/phylmd/raddim.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/raddim.h	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/raddim.h	(revision 644)
@@ -1,5 +1,5 @@
 !
-! $Header $
+! $Header$
 !
       INTEGER kdlon, kflev
-      PARAMETER (kdlon=klon,kflev=klev)
+      PARAMETER (kdlon=149,kflev=klev)
Index: /LMDZ4/trunk/libf/phylmd/radiornpb.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/radiornpb.F	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/radiornpb.F	(revision 644)
@@ -21,5 +21,5 @@
       REAL tautr(nbtr)
 C
-      WRITE(*,'(''PASSAGE radiornpb ... '',$)')
+c      WRITE(*,'(''PASSAGE radiornpb ... '',$)')
 C Attention, pour un pas de temps beaucoup plus petit que la decroissance!!!
 
@@ -48,5 +48,5 @@
       ENDDO
 c
-      WRITE(*,*) ' radiornpb OK'
+c      WRITE(*,*) ' radiornpb OK'
 c
       RETURN
Index: /LMDZ4/trunk/libf/phylmd/radlwsw.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/radlwsw.F	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/radlwsw.F	(revision 644)
@@ -89,14 +89,10 @@
       real topsw0(klon), toplw0(klon), solsw0(klon), sollw0(klon)
       real sollwdown(klon)
-cccIM 
+cIM output 3D 
       REAL*8 ZFSUP(KDLON,KFLEV+1)
       REAL*8 ZFSDN(KDLON,KFLEV+1)
       REAL*8 ZFSUP0(KDLON,KFLEV+1)
       REAL*8 ZFSDN0(KDLON,KFLEV+1)
-cIM
-cIM
-cIM   real sollwdownclr(klon) !LWdnSFCclr
-cIM   real toplwdown(klon) !LWdnTOA
-cIM   real toplwdownclr(klon) !LWdnTOAclr
+c
       REAL*8 ZFLUP(KDLON,KFLEV+1)
       REAL*8 ZFLDN(KDLON,KFLEV+1)
@@ -134,19 +130,15 @@
       REAL*8 ztopsw(kdlon), ztoplw(kdlon)
       REAL*8 zsolsw(kdlon), zsollw(kdlon), zalbpla(kdlon)
-cIM BEG
+cIM
       REAL*8 zsollwdown(kdlon)
-cIM   REAL*8 zsollwdown(kdlon), zsollwdownclr(kdlon)
-cIM   REAL*8 ztoplwdown(kdlon), ztoplwdownclr(kdlon)
-cIM END
+c
       REAL*8 ztopsw0(kdlon), ztoplw0(kdlon)
       REAL*8 zsolsw0(kdlon), zsollw0(kdlon)
       REAL*8 zznormcp
-cIM 080304   REAL swdn(klon,2),swdn0(klon,2),swup(klon,2),swup0(klon,2)
+cIM output 3D : SWup, SWdn, LWup, LWdn
       REAL swdn(klon,kflev+1),swdn0(klon,kflev+1)
       REAL swup(klon,kflev+1),swup0(klon,kflev+1)
-cIM BEG
       REAL lwdn(klon,kflev+1),lwdn0(klon,kflev+1)
       REAL lwup(klon,kflev+1),lwup0(klon,kflev+1)
-cIM END
 c-OB
 cjq the following quantities are needed for the aerosol radiative forcings
@@ -308,6 +300,4 @@
      .        ztoplw,zsollw,ztoplw0,zsollw0,
      .        zsollwdown,
-cIM  .        zsollwdown,zsollwdownclr,
-cIM  .        ztoplwdown,ztoplwdownclr)
      .        ZFLUP, ZFLDN, ZFLUP0,ZFLDN0)
 cIM ctes ds clesphys.h   CALL SW(PSCT, RCO2, zrmu0, zfract,
@@ -334,10 +324,4 @@
          sollwdown(iof+i) = zsollwdown(i)
 cIM
-cIM      sollwdownclr(iof+i) = zsollwdownclr(i)
-cIM BEG
-cIM      toplwdown(iof+i) = ztoplwdown(i)
-cIM      toplwdownclr(iof+i) = ztoplwdownclr(i)
-cIM END
-cIM 110304 BEG
          DO k = 1, kflev+1
          lwdn0 ( iof+i,k)   = ZFLDN0 ( i,k)
@@ -346,5 +330,5 @@
          lwup  ( iof+i,k)   = ZFLUP  ( i,k)
          ENDDO
-cIM 110304 END
+c
          topsw0(iof+i) = ztopsw0(i)
          toplw0(iof+i) = ztoplw0(i)
@@ -352,5 +336,5 @@
          sollw0(iof+i) = zsollw0(i)
          albpla(iof+i) = zalbpla(i)
-cIM 080304 BEG
+cIM
          DO k = 1, kflev+1
          swdn0 ( iof+i,k)   = ZFSDN0 ( i,k)
@@ -359,13 +343,4 @@
          swup  ( iof+i,k)   = ZFSUP  ( i,k)
          ENDDO !k=1, kflev+1
-cIM 080304 END
-c        swdn0 ( iof+i,1)   = ZFSDN0 ( i,1 )
-c        swdn0 ( iof+i,2)   = ZFSDN0 ( i,kflev + 1 )
-c        swdn  ( iof+i,1)   = ZFSDN  ( i,1 )
-c        swdn  ( iof+i,2)   = ZFSDN  ( i,kflev + 1 )
-c        swup0 ( iof+i,1)   = ZFSUP0 ( i,1 )
-c        swup0 ( iof+i,2)   = ZFSUP0 ( i,kflev + 1 )
-c        swup  ( iof+i,1)   = ZFSUP  ( i,1 )
-c        swup  ( iof+i,2)   = ZFSUP  ( i,kflev + 1 )
       ENDDO
 cjq-transform the aerosol forcings, if they have
@@ -2803,6 +2778,4 @@
      .              PTOPLW,PSOLLW,PTOPLW0,PSOLLW0,
      .              psollwdown,
-cIM  .              psollwdown,psollwdownclr,
-cIM  .              ptoplwdown,ptoplwdownclr)
      .              plwup, plwdn, plwup0, plwdn0)
       IMPLICIT none
@@ -2871,8 +2844,4 @@
 c Rajout LF
       real*8 psollwdown(kdlon)    ! LONGWAVE downwards flux at surface
-c Rajout IM
-cIM   real*8 psollwdownclr(kdlon) ! LONGWAVE CS downwards flux at surface
-cIM   real*8 ptoplwdown(kdlon)    ! LONGWAVE downwards flux at T.O.A.
-cIM   real*8 ptoplwdownclr(kdlon) ! LONGWAVE CS downwards flux at T.O.A.
 cIM
       REAL*8 plwup(KDLON,KFLEV+1)  ! LW up total sky
@@ -2953,9 +2922,5 @@
          PTOPLW0(i) = ZFLUC(i,1,KFLEV+1) + ZFLUC(i,2,KFLEV+1)
          psollwdown(i) = -ZFLUX(i,2,1)
-cIM
-cIM      psollwdownclr(i) = -ZFLUC(i,2,1)
-cIM      ptoplwdown(i) = ZFLUX(i,2,KFLEV+1)
-cIM      ptoplwdownclr(i) = ZFLUC(i,2,KFLEV+1)
-cIM
+c
 cIM attention aux signes !; LWtop >0, LWdn < 0
          DO k = 1, KFLEV+1
Index: /LMDZ4/trunk/libf/phylmd/stdlevvar.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/stdlevvar.F90	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/stdlevvar.F90	(revision 644)
@@ -3,7 +3,7 @@
 !
       SUBROUTINE stdlevvar(klon, knon, nsrf, zxli, &
- &                         u1, v1, t1, q1, z1, &
- &                         ts1, qsurf, rugos, psol, pat1, &
- &                         t_2m, q_2m, u_10m) 
+                           u1, v1, t1, q1, z1, &
+                           ts1, qsurf, rugos, psol, pat1, &
+                           t_2m, q_2m, t_10m, q_10m, u_10m, ustar)
       IMPLICIT NONE
 !-------------------------------------------------------------------------
@@ -16,4 +16,7 @@
 !
 ! I. Musat, 01.07.2002
+!
+!AM On rajoute en sortie t et q a 10m pr le calcule d'hbtm2 dans clmain
+!
 !-------------------------------------------------------------------------
 !
@@ -36,4 +39,8 @@
 ! q_2m---output-R- humidite relative a 2m
 ! u_10m--output-R- vitesse du vent a 10m
+!AM
+! t_10m--output-R- temperature de l'air a 10m
+! q_10m--output-R- humidite specifique a 10m
+! ustar--output-R- u*
 !
       INTEGER, intent(in) :: klon, knon, nsrf
@@ -43,5 +50,6 @@
       REAL, dimension(klon), intent(in) :: psol, pat1
 !
-      REAL, dimension(klon), intent(out) :: t_2m, q_2m, u_10m
+      REAL, dimension(klon), intent(out) :: t_2m, q_2m, ustar
+      REAL, dimension(klon), intent(out) :: u_10m, t_10m, q_10m
 !-------------------------------------------------------------------------
 #include "YOMCST.inc"
@@ -67,5 +75,5 @@
 ! ri1 : nb. de Richardson entre la surface --> la 1ere couche
       REAL, dimension(klon) :: ri1 
-      REAL, dimension(klon) :: ustar, testar, qstar
+      REAL, dimension(klon) :: testar, qstar
       REAL, dimension(klon) :: zdte, zdq   
 ! lmon : longueur de Monin-Obukhov selon Hess, Colman and McAvaney 
@@ -101,11 +109,9 @@
         ustar(i) = sqrt(cdram(i) * speed(i) * speed(i))
         zdte(i) = tpot(i) - ts1(i)
-!       PRINT*,'AVANT i,zdte',i,zdte(i)
-!IM cf FH : on prend le max : pour eviter le plantage sur SUN
+        zdq(i) = max(q1(i),0.0) - max(qsurf(i),0.0)
+!
+!
 !IM BUG BUG BUG       zdte(i) = max(zdte(i),1.e-10)
         zdte(i) = sign(max(abs(zdte(i)),1.e-10),zdte(i))
-!       PRINT*,'APRES i,zdte',i,zdte(i)
-!
-        zdq(i) = max(q1(i),0.0) - max(qsurf(i),0.0)
 !
         testar(i) = (cdrah(i) * zdte(i) * speed(i))/ustar(i)
@@ -260,4 +266,11 @@
 !
         u_10m(i) = u_zref_p(i) * ok_pred(i) + u_zref_c(i) * ok_corr(i)
+!
+!AM
+        q_zref_c(i) = q_zref(i)
+        temp_c(i) = temp(i)
+        t_10m(i) = temp_p(i) * ok_pred(i) + temp_c(i) * ok_corr(i)
+        q_10m(i) = q_zref_p(i) * ok_pred(i) + q_zref_c(i) * ok_corr(i)
+!MA
       ENDDO
 ! 
Index: /LMDZ4/trunk/libf/phylmd/tetalevel.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/tetalevel.F	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/tetalevel.F	(revision 644)
@@ -0,0 +1,130 @@
+c================================================================
+c================================================================
+      SUBROUTINE tetalevel(ilon,ilev,lnew,pgcm,pres,Qgcm,Qpres)
+c================================================================
+c================================================================
+
+      IMPLICIT none
+
+#include "dimensions.h"
+#include "dimphy.h"
+
+c================================================================
+c
+c Interpoler des champs 3-D u, v et g du modele a un niveau de
+c pression donnee (pres)
+c
+c INPUT:  ilon ----- nombre de points
+c         ilev ----- nombre de couches
+c         lnew ----- true si on doit reinitialiser les poids
+c         pgcm ----- pressions modeles
+c         pres ----- pression vers laquelle on interpolle
+c         Qgcm ----- champ GCM
+c         Qpres ---- champ interpolle au niveau pres
+c
+c================================================================
+c
+c   arguments :
+c   -----------
+
+      INTEGER ilon, ilev
+      logical lnew
+
+      REAL pgcm(ilon,ilev)
+      REAL Qgcm(ilon,ilev)
+      real pres
+      REAL Qpres(ilon)
+
+c   local :
+c   -------
+c
+#include "paramet.h"
+c
+      INTEGER lt(ip1jmp1), lb(ip1jmp1)
+      REAL ptop, pbot, aist(ip1jmp1), aisb(ip1jmp1)
+      save lt,lb,ptop,pbot,aist,aisb
+
+      INTEGER i, k
+c
+c     PRINT*,'tetalevel pres=',pres
+c=====================================================================
+      if (lnew) then
+c   on réinitialise les réindicages et les poids
+c=====================================================================
+
+
+c Chercher les 2 couches les plus proches du niveau a obtenir
+c
+c Eventuellement, faire l'extrapolation a partir des deux couches
+c les plus basses ou les deux couches les plus hautes:
+      DO 130 i = 1, ilon
+cIM      IF ( ABS(pres-pgcm(i,ilev) ) .LT.
+         IF ( ABS(pres-pgcm(i,ilev) ) .GT.
+     .        ABS(pres-pgcm(i,1)) ) THEN
+            lt(i) = ilev     ! 2
+            lb(i) = ilev-1   ! 1
+         ELSE
+            lt(i) = 2
+            lb(i) = 1
+         ENDIF
+cIM   PRINT*,'i, ABS(pres-pgcm),ABS(pres-pgcm)',
+cIM  .i, ABS(pres-pgcm(i,ilev)),ABS(pres-pgcm(i,1))
+  130 CONTINUE
+      DO 150 k = 1, ilev-1
+         DO 140 i = 1, ilon
+            pbot = pgcm(i,k)
+            ptop = pgcm(i,k+1)
+cIM         IF (ptop.LE.pres .AND. pbot.GE.pres) THEN
+            IF (ptop.GE.pres .AND. pbot.LE.pres) THEN
+               lt(i) = k+1
+               lb(i) = k
+            ENDIF
+  140    CONTINUE
+  150 CONTINUE
+c
+c Interpolation lineaire:
+c
+      DO i = 1, ilon
+c interpolation en logarithme de pression:
+c
+c ...   Modif . P. Le Van    ( 20/01/98) ....
+c       Modif Frédéric Hourdin (3/01/02)
+
+c       IF(pgcm(i,lb(i)).NE.0.OR.
+c    $     pgcm(i,lt(i)).NE.0.) THEN
+c
+c       PRINT*,'i,lb,lt,2pgcm,pres',i,lb(i),
+c    .  lt(i),pgcm(i,lb(i)),pgcm(i,lt(i)),pres
+c
+        aist(i) = LOG( pgcm(i,lb(i))/ pres )
+     .       / LOG( pgcm(i,lb(i))/ pgcm(i,lt(i)) )
+        aisb(i) = LOG( pres / pgcm(i,lt(i)) )
+     .       / LOG( pgcm(i,lb(i))/ pgcm(i,lt(i)))
+      enddo
+
+
+      endif ! lnew
+
+c======================================================================
+c    inteprollation
+c======================================================================
+
+      do i=1,ilon
+         Qpres(i)= Qgcm(i,lb(i))*aisb(i)+Qgcm(i,lt(i))*aist(i)
+cIM      PRINT*,'i,Qgcm,Qpres',i,Qgcm(i,lb(i)),aisb(i),
+cIM  $   Qgcm(i,lt(i)),aist(i),Qpres(i)
+      enddo
+c
+c Je mets les vents a zero quand je rencontre une montagne
+      do i = 1, ilon
+cIM      if (pgcm(i,1).LT.pres) THEN
+         if (pgcm(i,1).GT.pres) THEN
+c           Qpres(i)=1e33
+            Qpres(i)=1e+20
+cIM         PRINT*,'i,pgcm(i,1),pres =',i,pgcm(i,1),pres
+         endif
+      enddo
+
+c
+      RETURN
+      END
Index: /LMDZ4/trunk/libf/phylmd/transp_lay.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/transp_lay.F	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/transp_lay.F	(revision 644)
@@ -0,0 +1,49 @@
+      SUBROUTINE transp_lay (paprs,tsol,
+     e                   t, q, u, v, geom,
+     s                   vtran_e, vtran_q, utran_e, utran_q)
+c
+      IMPLICIT none
+c======================================================================
+c Auteur(s): Z.X.Li (LMD/CNRS)
+c Date: le 25 avril 1994
+c Objet: Calculer le transport de l'energie et de la vapeur d'eau
+c======================================================================
+c
+#include "dimensions.h"
+#include "dimphy.h"
+#include "YOMCST.h"
+c
+      REAL paprs(klon,klev+1), tsol(klon)
+      REAL t(klon,klev), q(klon,klev), u(klon,klev), v(klon,klev)
+      REAL utran_e(klon,klev), utran_q(klon,klev)
+      REAL vtran_e(klon,klev), vtran_q(klon,klev)
+c
+      INTEGER i, l
+c     ------------------------------------------------------------------
+      REAL geom(klon,klev), esh
+c     ------------------------------------------------------------------
+      DO l = 1, klev
+      DO i = 1, klon
+         utran_e(i,l) = 0.0
+         utran_q(i,l) = 0.0
+         vtran_e(i,l) = 0.0
+         vtran_q(i,l) = 0.0
+      ENDDO
+      ENDDO
+c
+      DO l = 1, klev
+      DO i = 1, klon
+         esh = RCPD*t(i,l) + RLVTT*q(i,l) + geom(i,l)
+         utran_e(i,l)=utran_e(i,l)+ u(i,l)*esh*
+     .                (paprs(i,l)-paprs(i,l+1))/RG
+         utran_q(i,l)=utran_q(i,l)+ u(i,l)*q(i,l)
+     .                *(paprs(i,l)-paprs(i,l+1))/RG
+         vtran_e(i,l)=vtran_e(i,l)+ v(i,l)*esh*
+     .                (paprs(i,l)-paprs(i,l+1))/RG
+         vtran_q(i,l)=vtran_q(i,l)+ v(i,l)*q(i,l)
+     .                *(paprs(i,l)-paprs(i,l+1))/RG
+      ENDDO
+      ENDDO
+c
+      RETURN
+      END
Index: /LMDZ4/trunk/libf/phylmd/undefSTD.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/undefSTD.F	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/undefSTD.F	(revision 644)
@@ -0,0 +1,83 @@
+      SUBROUTINE undefSTD(nlevSTD,itap,tlevSTD,
+     $           ecrit_hf,
+     $           oknondef,tnondef,tsumSTD)
+      IMPLICIT none
+c
+c====================================================================
+c
+c I. Musat : 09.2004
+c
+c Calcul * du nombre de pas de temps (FLOAT(ecrit_XXX)-tnondef)) 
+c          ou la variable tlevSTD est bien definie (.NE.1.E+20), 
+c et 
+c        * de la somme de tlevSTD => tsumSTD
+c
+c nout=1 !var. journaliere "day" moyenne sur tous les pas de temps
+c        ! de la physique
+c nout=2 !var. mensuelle "mth" moyennee sur tous les pas de temps
+c        ! de la physique
+c nout=3 !var. mensuelle "NMC" moyennee toutes les 6heures
+c
+c
+c NB: mettre "inst(X)" dans le write_histXXX.h !
+c====================================================================
+c
+#include "dimensions.h"
+      integer jjmp1
+      parameter (jjmp1=jjm+1-1/jjm)
+#include "dimphy.h"
+c variables Input
+      INTEGER nlevSTD, klevSTD, itap
+      PARAMETER(klevSTD=17)
+      INTEGER ecrit_hf
+c
+c variables locales
+      INTEGER i, k, nout
+      PARAMETER(nout=3) !nout=1 : day; =2 : mth; =3 : NMC
+c
+c variables Output
+      REAL tlevSTD(klon,klevSTD), tsumSTD(klon,klevSTD,nout)
+      LOGICAL oknondef(klon,klevSTD,nout)
+      REAL tnondef(klon,klevSTD,nout)
+c
+c calcul variables tous les pas de temps de la physique 
+c
+      DO k=1, nlevSTD
+       DO i=1, klon
+        IF(tlevSTD(i,k).EQ.1E+20) THEN
+         IF(oknondef(i,k,1)) THEN          
+          tnondef(i,k,1)=tnondef(i,k,1)+1.
+         ENDIF !oknondef(i,k)
+c
+         IF(oknondef(i,k,2)) THEN          
+          tnondef(i,k,2)=tnondef(i,k,2)+1.
+         ENDIF !oknondef(i,k)
+c
+        ELSE IF(tlevSTD(i,k).NE.1E+20) THEN
+         tsumSTD(i,k,1)=tsumSTD(i,k,1)+tlevSTD(i,k)
+         tsumSTD(i,k,2)=tsumSTD(i,k,2)+tlevSTD(i,k)
+        ENDIF 
+       ENDDO !i
+      ENDDO !k
+c
+c calcul variables toutes les 6h
+c
+      IF(MOD(itap,ecrit_hf).EQ.0) THEN
+c
+       DO k=1, nlevSTD
+        DO i=1, klon
+         IF(tlevSTD(i,k).EQ.1E+20) THEN
+          IF(oknondef(i,k,3)) THEN          
+           tnondef(i,k,3)=tnondef(i,k,3)+1.
+          ENDIF !oknondef(i,k)
+c
+         ELSE IF(tlevSTD(i,k).NE.1E+20) THEN
+         tsumSTD(i,k,3)=tsumSTD(i,k,3)+tlevSTD(i,k)
+         ENDIF 
+        ENDDO !i
+       ENDDO !k
+
+      ENDIF !MOD(itap,ecrit_hf).EQ.0
+c
+      RETURN
+      END  
